#include <Wire.h>
#include <Strela.h>


//#define S1
#define BUTTON_DBG S2
#define BUTTON_ON  S3
#define BUTTON_CAL S4

#define LED_ON 		L1
#define LED_CAL 	L2
#define LED_DBG 	L3
//#define L4;

#define SENSOR_R        P5       //пин, к которому подключен первый датчик
#define SENSOR_L        P6       //пин, к которому подключен второй датчик
#define SENSOR_C  		P7       //пин, к которому подключен центральный датчик
//#define BUZZER_PIN		D12		 // BUZZER 

#define COLOR_B         100      //Цветовая граница между белым и черным
#define DELAY			100		 //Время периодического опроса всей системы 

#define KP_PIN			P8		 //
#define KD_PIN			P9		 //
#define KI_PIN			P11		 //
#define V_PIN			P12		 //

#define K_MAX			2.0
#define VAR				(1023/K_MAX)
#define LPF

//#define POT_EN				// 
//#define DBG					// Режим отладки

float S_r = 0;              //показания с первого датчика, подключенного к порту P5
float S_l = 0;              //показания со второго датчика, подключенного к порту P6
float S_c = 0;              //показаняи с центрального датчика, подключенного к порту P7

int center = 0;
int right = 0;
int left = 0;
int Es = 0;

float P = 0;                //пропорциональный регулятор
float kp = 0.1;	

float I = 0;                //интегральный регулятор
float ki = 0;	

float D = 0;                //дифференциальный регулятор
float kd = 0;					

int   U=0;					// Итоговое компенсирующее воздействие
int   v = 20;              // начальная скорость 42.5

float E = 0;				// рассогласование
float Eold = 0;				// Предыдущее рассогласование

float Y = 0;				// 
float Yold = 0;				// 
float a = 0;

int	  m_l = 0;              //скорость мотора 1
int   m_r = 0;              //скорость мотора 2

int   Power = 0;		    // Статус переменная для управления питанием робота
int   Dbg = 0;		    // 
int   Cal = 0;

unsigned long previousMillis = 0;        // will store last time LED was updated
unsigned long currentMillis 	;

void setup() 
{
  motorConnection(0,1);
  Serial.begin(115200); 
  //pinMode(BUZZER_PIN, OUTPUT);
  tone(BUZZER, 1000, 150); 
  
}

void loop() {

if (uDigitalRead(BUTTON_ON) == HIGH)	
{
	delay(300); 
	if(uDigitalRead(BUTTON_ON) == HIGH)
		{
			if (Power == 1) {Power = 0;uDigitalWrite(LED_ON,LOW);}
			else {Power = 1;	uDigitalWrite(LED_ON,HIGH);}
		}
}
if (uDigitalRead(BUTTON_DBG) == HIGH)	
{
	delay(300); 
	if(uDigitalRead(BUTTON_DBG) == HIGH)
		{
			if (Dbg == 1) {Dbg =0; uDigitalWrite(LED_DBG,LOW);}
			else {Dbg = 1; uDigitalWrite(LED_DBG,HIGH);}
		}
}
if (uDigitalRead(BUTTON_CAL) == HIGH)	
{
	delay(300); 
	if(uDigitalRead(BUTTON_CAL) == HIGH)
		{
			if (Cal == 1) {Cal =0; uDigitalWrite(LED_CAL,LOW);}
			else {Cal = 1; uDigitalWrite(LED_CAL,HIGH);}
		}
}



// Если включено,то
if (Power == 1)
{
	previousMillis = millis();
//Serial.println("ON");
	uDigitalWrite(LED_ON,HIGH);
	


	// Считываем показания с датчиков (0-1024)
  S_r = analogRead(SENSOR_R);
  S_l = analogRead(SENSOR_L);
  S_c = analogRead(SENSOR_C);

  
 // Масштабирование (0-255)
 // S_r = (S_r / 1024) * 255;
 // S_l = (S_l / 1024) * 255;

 S_r = (S_r/4);
 S_l = (S_l/4);
 S_c = (S_c/4)*1.2;
    	
 if (Dbg==1)
 {
	Serial.print("S_r = ");
	Serial.println(S_r);
	Serial.print("S_l = ");
	Serial.println(S_l);
	Serial.print("S_c = ");
	Serial.println(S_c);
 }


 
  //E = S_r - S_l - Es;	// вычисляем рассогласование между левым и правым датчиком
  E = S_c - (S_l+S_r)/2 ;	// вычисляем рассогласование между левым и правым датчиком
  
  P = E*kp;			// расчет пропорциональной составляющей (скорость на линии)
  //I = I+ki*E;		// интегральный регулятор (ускорение по линии)
  D = (E-Eold)*kd;  // дифференциальный регулятор (влияет на резкость на поворотах)
  Eold=E;
  
  
  U = P+I+D;
  
  Y = a*U+(1-a)*Yold; 
  Yold = Y;
 
  
  if (Dbg==1)
	{
		Serial.print("E = ");
		Serial.println(E);
		Serial.print("P = ");
		Serial.println(P);
		//Serial.print("I = ");
		//Serial.println(I);
		Serial.print("D = ");
		Serial.println(D);
		Serial.print("U = ");
		Serial.println(U);
	 } 

  
  
  m_r = v + Y;
  if 		(m_r > 255) 	{m_r = 255;}		//тупо ограничитель 
  else if	(m_r < -255)	{m_r = -255;}		//тупо ограничитель 
  
  m_l = v - Y;
  if 		(m_l > 255) 	{m_l = 255;}		//тупо ограничитель 
  else if	(m_l < -255)	{m_l = -255;}		//тупо ограничитель 
 
  drive(m_r, m_l);
  

  
  if (Dbg==1){drive(0, 0);delay(300);}
  
	delay(3);

  
//  Serial.print("m_l = ");
//  Serial.println(m_l);
//  Serial.print("m_r = ");
//  Serial.println(m_r);
  //currentMillis = millis();
  //unsigned int A;
  //A = currentMillis - previousMillis;
  
  //Serial.println(A); 
} 
 else { drive(0,0); }
 
 	/***********  Начальная установка коэффициентов согласно положению подстроечников  ***********/
if (Cal==1)
{
	a = analogRead(KI_PIN);		
	kp = analogRead(KP_PIN);
	kd = analogRead(KD_PIN);
	v = analogRead(V_PIN);

	a = a*0.5/VAR;		//Значение от 0 до K_MAX
	kp = kp/VAR;
	kd = kd*30/VAR;
	v = v/4;			// 0-255
	
	  //center = analogRead(center_sensor);
	  right = analogRead(SENSOR_R);
	  left = analogRead(SENSOR_L);
	  Es = right - left;
	  
	Serial.print("Right = ");
	Serial.println(right);
	Serial.print("Left = ");
	Serial.println(left);
	Serial.print("Es = ");
	Serial.println(Es);	
	  
	
	Serial.print("a = ");
	Serial.println(a);
	Serial.print("kp = ");
	Serial.println(kp);
	Serial.print("kd = ");
	Serial.println(kd);	
	Serial.print("v = ");
	Serial.println(v);

	
	
	delay(300);
}
/*********************************************************************************************/	
 

}




